using System;
using System.Collections.Generic;
using System.Text;

namespace PICkit2V2
{
    public class DeviceData
    {
        public uint[] ProgramMemory;
        public uint[] EEPromMemory;
        public uint[] ConfigWords;
        public uint[] UserIDs;
        public uint OSCCAL;
        public uint BandGap;
        
        public DeviceData(uint progMemSize, ushort eeMemSize, byte numConfigs, byte numIDs, 
                            uint memBlankVal, int eeBytes, int idBytes, ushort[] configBlank)
        {   // Overloaded Constructor
            ProgramMemory = new uint[progMemSize];
            EEPromMemory = new uint[eeMemSize];
            ConfigWords = new uint[numConfigs];
            UserIDs = new uint[numIDs];
            
            //init program memory to blank
            for (int i = 0; i < progMemSize; i++)
            {
                ProgramMemory[i] = memBlankVal;
            }
            
            //init eeprom to blank
            uint eeBlankVal = 0xFF;
            if (eeBytes == 2)
            {
                eeBlankVal = 0xFFFF;
            }
            for (int i = 0; i < eeMemSize; i++)
            {
                EEPromMemory[i] = eeBlankVal;                  // 8-bit eeprom will just use 8 LSBs
            }

            //init configuration to blank
            for (int i = 0; i < numConfigs; i++)
            {
                ConfigWords[i] = configBlank[i];
            }

            //init user ids to blank
            uint idBlank = memBlankVal;
            if (idBytes == 1)
            {
                idBlank = 0xFF;
            }
            for (int i = 0; i < numIDs; i++)
            {
                UserIDs[i] = idBlank;
            }   
            
            //init OSSCAL & BandGap
            OSCCAL = memBlankVal;
            BandGap = memBlankVal;
        
        }
    }
}
