; example2.nsi
;
; This script is based on example1.nsi, but it remember the directory, 
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install example2.nsi into a directory that the user selects,

;--------------------------------

; The name of the installer
Name "QwikProgram 2"

; The file to write
OutFile "QwikProgram 2 Setup.exe"

; The default installation directory
InstallDir $PROGRAMFILES\QwikProgram2

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\QwikProgram2" "Install_Dir"

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "QwikProgram 2 (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR
  
  ; Put file there
  File "help.html"
  File "PICkit2Diagram.jpg"
  File "PK2DeviceFile.dat"
  File "PK2V020100.hex"
  File "qbPIC18F452.hex"
  File "qbPIC18F452.hex.vector"
  File "qbPIC18F4520.hex"
  File "qbPIC18F4520.hex.vector"
  File "QwikProgram2.exe"
  File "QwikProgram2.nsi"

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\QwikProgram2 "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QwikProgram2" "DisplayName" "QwikProgram 2"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QwikProgram2" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QwikProgram2" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QwikProgram2" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Start menu shortcuts
Section "Start menu shortcuts"

  CreateDirectory "$SMPROGRAMS\QwikProgram 2"
  CreateShortCut "$SMPROGRAMS\QwikProgram 2\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\QwikProgram 2\QwikProgram 2.lnk" "$INSTDIR\QwikProgram2.exe" "" "$INSTDIR\QwikProgram2.exe" 0
  
SectionEnd

; Desktop icon
Section "Desktop icon" SecDesktop
  CreateShortcut "$DESKTOP\QwikProgram 2.lnk" "$INSTDIR\QwikProgram2.exe" "" "$INSTDIR\QwikProgram2.exe" 0
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\QwikProgram2"
  DeleteRegKey HKLM SOFTWARE\QwikProgram2

  ; Remove files and uninstaller
  Delete $INSTDIR\*.*

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\QwikProgram 2\*.*"
  Delete "$DESKTOP\QwikProgram 2.lnk"
  
  ; Remove directories used
  RMDir "$SMPROGRAMS\QwikProgram 2"
  RMDir "$INSTDIR"

SectionEnd
